import logging
import os

import grpc
from oauthlib.oauth2 import BackendApplicationClient

from perxis.auth import OAuth2Plugin
from perxis.collections import collections_pb2, collections_pb2_grpc


def _load_credential_from_file(filepath):
    real_path = os.path.join(os.path.dirname(__file__), filepath)
    with open(real_path, 'rb') as f:
        return f.read()


def main():
    client_id = 'YGPQSAUPgco4iTQxNejtXDjFVwPmYT3n'
    client_secret = '_d6F-VlQGmcsU25AXIoCU4EU3v56-28P6jwUHkutg_hSPseConphyLs3F-Buuq1h'
    token_url = 'https://adwz.auth0.com/oauth/token'
    audience = 'some'

    oauth2_plugin = OAuth2Plugin(
        client=BackendApplicationClient(client_id=client_id),
        client_secret=client_secret,
        token_url=token_url,
        audience=audience
    )

    call_credentials = grpc.metadata_call_credentials(oauth2_plugin, name='auth')
    channel_credentials = grpc.ssl_channel_credentials(
        root_certificates=_load_credential_from_file('credentials/root.crt')
    )
    composite_credentials = grpc.composite_channel_credentials(
            channel_credentials, call_credentials
    )
    with grpc.secure_channel('envoy.perxis.pt.perx.ru:443', composite_credentials) as channel:
        stub = collections_pb2_grpc.CollectionsStub(channel)
        collections = stub.List(collections_pb2.ListRequest(space_id="c2qcp9cuaccmpj8lmom0", env_id="master"))
        print(collections)


if __name__ == '__main__':
    logging.basicConfig(level=logging.INFO)
    main()
